unit IICalcShareMem;

{*******************************************************}
{                                                       }
{       IICalc SDK                                      }
{       Memory Manager                                  }
{                                                       }
{       2002 Demoonlit                                  }
{                                                       }
{*******************************************************}

{
	DLL̃C\[X{̂uses߂̐擪ŎQƂĂ.
	DLL̃C\[Xŕϐ錾Ȃł.
	IICalcCore.dllBorlandMM.dll݊Ń[Ǘ̂
	BorlandMM.dll͕svł. ShareMem.pasusesȂł.
}

interface

const
	Core = 'iicalccore.dll';

function SysGetMem(Size: Integer): Pointer;
				external Core name '@Borlndmm@SysGetMem$qqri';

function SysFreeMem(P: Pointer): Integer;
				external Core name '@Borlndmm@SysFreeMem$qqrpv';

function SysReallocMem(P: Pointer; Size: Integer): Pointer;
				external Core name '@Borlndmm@SysReallocMem$qqrpvi';

type
	IMain = interface(IInterface)
		function GetApplication: IUnknown;
		function GetCurrentThread: IUnknown;
	end;

procedure SetMain(const Value: IMain);
				external Core name 'IICalc@SetMain';

implementation

function GetModuleHandle(lpModuleName: PChar): Integer; stdcall;
				external 'kernel32.dll' name 'GetModuleHandleA';

function GetProcAddress(hModule: Integer; lpProcName: PChar): Pointer; stdcall;
				external 'kernel32.dll' name 'GetProcAddress';

procedure InitMemoryManager;
var
	SharedMemoryManager: TMemoryManager;
	MM: HMODULE;
begin
	// force a static reference to borlndmm.dll, so we don't have to LoadLibrary
	SharedMemoryManager.GetMem := SysGetMem;

	MM := GetModuleHandle(Core);

	SharedMemoryManager.GetMem := GetProcAddress(MM, '@Borlndmm@SysGetMem$qqri');
	SharedMemoryManager.FreeMem := GetProcAddress(MM, '@Borlndmm@SysFreeMem$qqrpv');
	SharedMemoryManager.ReallocMem := GetProcAddress(MM, '@Borlndmm@SysReallocMem$qqrpvi');

	SetMemoryManager(SharedMemoryManager);
end;

initialization

	Assert(not IsMemoryManagerSet);
	InitMemoryManager;

end.
