library Random;

uses
	IICalcShareMem,
	IICalcIntf;

{$R *.res}

type
	T = class
		class function R(const Arguments: array of IExpression; const Environment: IEnvironment): IValue;
	end;

class function T.R(const Arguments: array of IExpression; const Environment: IEnvironment): IValue;
begin
	Result := (GetApplication as IValueManager).CreateRealValue(System.Random)
end;

var
	Type_nil: array[0..0] of PType = (nil);
	RandomFunc: TFunction = (Name: 'Random'; Execute: T.R; ArgumentTypes: @Type_nil);

begin
	RandomFunc.ResultType := (GetApplication as IValueManager).RealType;
	(GetApplication as ITemplateManager).RegisterFunction(@RandomFunc);

	Randomize;
end.
